#include <stdlib.h>
#include <stdio.h>
#include <string.h>

FILE * infile;
FILE * headerfile;
FILE * outfile;

void do_exit(int code);
void arg_setup(int argc, char * argv[]);

char colors[65536];
char line_in[512];

int main(int argc, char * argv[]) {
   arg_setup(argc,argv);

   // initial fill with black
   for(int i = 0; i<65536; i++) colors[i] = 0;

   char * token;
   int num_pixels = 0;
   int x, y_sys, y, color, offset;

   // read from infile
   while(fgets(line_in,510,infile)) {
      token = strtok( &line_in[0] , " =\t\n");
      if(token==NULL) continue;
      if(strcmp(token,"-->Pixel")==0) {
         token = strtok(NULL," =\t\n");
         token = strtok(NULL," =\t\n");
         token = strtok(NULL," =\t\n");
         x = atoi(token);
         token = strtok(NULL," =\t\n");
         token = strtok(NULL," =\t\n");
         y_sys = atoi(token);
         token = strtok(NULL," =\t\n");
         token = strtok(NULL," =\t\n");
         color = atoi(token);
         if(x>255 | y_sys >255 | color > 255) {
            continue;
         }
         if(x<0 | y<0 | color <0) {
            printf("Error: pixels/colors must be [0,255]\n");
            do_exit(-1);
         }
         y = 255 - y_sys;
         offset = 256 * y + x;
         if(offset>65535 | offset<0) {
            printf("Error: Integer may be out of bounds.\n");
            do_exit(-1);
         }
         colors[offset] = color;
         num_pixels++;
      }
   }

   // start writing to outfile
   x = fgetc(headerfile);
   while(x!=EOF) {
      fputc(x,outfile);
      x = fgetc(headerfile);
   }

   // append the bitmap
   for(int i=0; i<65536; i++) {
      fputc(colors[i],outfile);
   }

   printf("Detected %i pixel writes.\n",num_pixels);

   do_exit(0);
}

void do_exit(int code) {
   fcloseall();
   exit(code);
}

void arg_setup(int argc, char * argv[]) {
   // arg checking
   if(argc!=3) {
      printf("Syntax error. Correct syntax is:\n");
      printf("bmpgen <infile> <outfile>\n");
      do_exit(-1);
   }

   // input file setup
   infile = fopen(argv[1],"r");
   if(infile==NULL) {
      printf("Could not open file: %s\n", argv[1]);
      do_exit(-1);
   }
   headerfile = fopen("header","r");
   if(headerfile==NULL) {
      printf("Could not open file \"header\"\n");
      do_exit(-1);
   }

   // output file setup
   outfile = fopen(argv[2],"w");
   if(outfile==NULL) {
      printf("Could not open file for writing: %s\n",argv[2]);
      do_exit(-1);
   }

}
